/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: PSParser.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_PS_PARSER_HPP_
#define _TOPS_PS_PARSER_HPP_

#include <iostream>
#include <string>

#include <boost/shared_ptr.hpp>

namespace tops {

	class ConditionPart;
	class FactOrRule;
	class Fact;
	typedef boost::shared_ptr<Fact> FactPtr;
	class Rule;
	typedef boost::shared_ptr<Rule> RulePtr;

	class PSParserImpl;

	/**
	 * 文法を解釈して各種のオブジェクトを構築するパーサです。
	 *
	 * @author トゥイー
	 */
	class PSParser {
	private:
		PSParserImpl* m_this;

	public:
		PSParser();
		~PSParser();

	private:
		PSParser(const PSParser&);
		const PSParser& operator=(const PSParser&);

	public:
		/**
		 * 事実かプロダクションルールを取得します。
		 */
		bool getFactOrRule(std::istream& stream, FactOrRule& result);

		/**
		 * 事実かプロダクションルールを取得します。
		 */
		bool getFactOrRule(const std::string& buffer, FactOrRule& result);

		/**
		 * 事実を取得します。
		 */
		FactPtr getFact(std::istream& stream);

		/**
		 * 事実を取得します。
		 */
		FactPtr getFact(const std::string& buffer);

		/**
		 * プロダクションルールを取得します。
		 */
		RulePtr getRule(std::istream& stream);

		/**
		 * プロダクションルールを取得します。
		 */
		RulePtr getRule(const std::string& buffer);

	public:
		/**
		 * 条件部を取得します。
		 */
		ConditionPart getConditionPart(std::istream& stream);

		/**
		 * 条件部を取得します。
		 */
		ConditionPart getConditionPart(const std::string& stream);

	public:
		/**
		 * エラーメッセージを取得します。
		 */
		const std::string& getErrorMessage() const;
	};

}  // namespace tops

#endif
